/**********************************************************************
* FILENAME
*   codec_poll1.c
*
* DESCRIPTION
*   Polling version of simple codec test
*
*  Rev 3.0	17 May 2001	 J. Echard
*
*----------------------------------------------------------------------
*  HISTORY
*  Rev 1.00  Created by Z.Zhang
*  Rev 2.00  Mods - Updated for C6711 DSK
*  Rev 2.10  Mods - Removed SDRAM parameters      
*  Rev 3.00  Modified for the PCM3003 using McBSP1 
**********************************************************************/
#include <stdio.h>
#include <c6x.h>
#include "c6211dsk.h"
#include "codec_poll1.h"
/*********************************************************
 *  Declarations
 *********************************************************/

short Input_Data;
short Output_Data;
//short Output_Data= 0x16EF;  /* Debug 0001011011101111 for oscliscope */
short Output_Data= 0x5555;    /* For Debug */
short buffercount = 0;		  /* Define Input (1) and Output (2) buffers for graphs */
short bufferlength = 256;
short buffer1[256];
short buffer2[256];
 
int main()
{
 
  /* dsp and periphiral initialization */    
  CSR=0x100;	        	       /* disable all interrupts            */
  IER=1;                           /* disable all interrupts except NMI */
  ICR=0xffff;                      /* clear all pending interrupts      */

  *(unsigned volatile int *)EMIF_GCR = 0x3300; 	     /* EMIF global control               */
  *(unsigned volatile int *)EMIF_CE1 = 0xffffff03;	 /* EMIF CE1 control, 8bit async      */
 
  McBSP1_init();
  codec_playback();   
  
  return(0);

}

void McBSP1_init()
{
     /* set up McBSP1                                                                   */
    *(unsigned volatile int *)McBSP1_SPCR = 0;		   /*  reset serial port                         */
    *(unsigned volatile int *)McBSP1_PCR = 0x000C;          /*  set pin control reg.;                     */
    *(unsigned volatile int *)McBSP1_RCR = 0x80400040;        /*  0bit delay,set rx control reg. one 16 bit data/frame */
    *(unsigned volatile int *)McBSP1_XCR = 0x80400040;        /*  0bit delay, set tx control reg. one 16 bit data/frame */
    *(unsigned volatile int *)McBSP1_DXR = 0;				/* write first word */
    *(unsigned volatile int *)McBSP1_SPCR = 0x10001;       /*  setup SP control reg., take out of reset, w RJUST=0;                    */
}

void McBSP1_write(int out_data)
{
  int temp;
  temp = *(unsigned volatile int *)McBSP1_SPCR & 0x20000;
  while ( temp == 0)
  {
    temp = *(unsigned volatile int *)McBSP1_SPCR & 0x20000;
  }
//  *(unsigned volatile int *)McBSP1_DXR = out_data;
  *(volatile int *)McBSP1_DXR = out_data;
}

int McBSP1_read()
{
  int temp;
  temp = *(unsigned volatile int *)McBSP1_SPCR & 0x2;
  while ( temp == 0)
  {
    temp = *(unsigned volatile int *)McBSP1_SPCR & 0x2;
  }
//  temp = *(unsigned volatile int *)McBSP1_DRR;
  temp = *(volatile int *)McBSP1_DRR;
  return temp;
}
 
void codec_playback()
{
 
  while(1)  /* play back about 5 minutes */
  {
    Input_Data = McBSP1_read();



    Output_Data = sineGen();	  /* use with sinGen output */
//    Output_Data = Output_Data & 0xFFFF; /* use with sinGen output */

//	Output_Data = Input_Data;  /* use for data loopback */

    McBSP1_write(Output_Data);
  	buffer1[buffercount] = Input_Data;
  	buffer2[buffercount] = Output_Data;

     McBSP1_write(Output_Data);
      
    buffercount++;
      
      if (buffercount==bufferlength)
      	{
      	buffercount=0;
      	}
  }
}
